
{
open TypeDef
open Util
open Parser
exception Eof
}

rule token = parse
    [' ' '\t']	{ token lexbuf }
  | '{'[^'}']*'}' { token lexbuf }
  | ['\n']	{ line := !line + 1; token lexbuf }
  | ['0'-'9']+	{ CONST_INT(Lexing.lexeme lexbuf)}
  | ['0'-'9']+'.'['0'-'9']* 	{ CONST_FLOAT(Lexing.lexeme lexbuf) }
  | "vrai"	{ CONST_BOOL("1") }
  | "faux"	{ CONST_BOOL("0")}
  | '+'		{ PLUS }
  | '-'		{ MINUS }
  | '*'		{ TIMES }
  | '/'		{ DIV }
  | '('		{ G_PAREN }
  | ')'		{ D_PAREN }
  | "=="	{ EST_EGALE }
  | ">"		{ EST_SUPERIEUR }
  | "<"		{ EST_INFERIEUR }
  | "et"	{ ET }
  | "ou"	{ OU }
  | "non"	{ NON }
  | '='		{ EGALE }
  | "afficher"	{ AFFICHER }
  | "tantque"	{ TANTQUE }
  | "faire"     { FAIRE }
  | "fin_faire" { FIN_FAIRE }
  | "si"	{ SI }
  | "alors"	{ ALORS }
  | "sinon"	{ SINON }
  | "rien"	{ RIEN }
  | "var:"	{ DECLARATION }
  | "fin_var"	{ FIN_DECLARATION }
  | "debut"     { DEBUT }
  | "fin_si"    { FIN_SI }
  | "fin"       { FIN }
  | "booleen"	{ BOOLEEN }
  | "entier"	{ ENTIER }
  | "reel"	{ REEL }
  | ';'		{ PV }
  | ','		{ VIRGULE }
  | '"'[^'"']*'"' { CHAINE(Lexing.lexeme lexbuf) }
  | ['a'-'z''A'-'Z']+	{ VAR(Lexing.lexeme lexbuf) }
  | eof		{ EOF }
