%{

open TypeDef
open Util

%}
%token <string> CHAINE
%token <string> VAR
%token <string> CONST_INT 
%token <string> CONST_FLOAT 
%token <string> CONST_BOOL
%token FIN DECLARATION FIN_DECLARATION FAIRE FIN_FAIRE
%token RIEN TANTQUE VIRGULE PV SI ALORS SINON FIN_SI
%token REEL EGALE DEBUT FIN STATIC FIN_STATIC
%token EST_EGALE EST_SUPERIEUR EST_INFERIEUR OU ET
%token BOOLEEN FONCTION RETOURNE 
%token ENTIER
%token AFFICHER
%token PLUS MINUS TIMES DIV
%token D_PAREN G_PAREN
%token EOF
%token NON
%left NON
%left PLUS MINUS
%left TIMES DIV
%left EST_EGALE EST_SUPERIEURE EST_INFERIEURE
%left ET OU
%nonassoc UMINUS
%start depart
%type <unit> depart
%%

depart:
  entree_bloc
  bloc_declaration bloc_instruction PV EOF
	{	
	 Printf.printf "%s\n" "#include <stdio.h>";
	  tableVar#print;
  	 (new prog $3)#print;
	  exit 0;
	  flush stdout
	}
;

entree_bloc:  	{ tableVar#empiler_bloc }
;

bloc_declaration:
    DECLARATION suite_declaration FIN_DECLARATION 	{ }
    |						{ }
;

suite_declaration:
  | declaration PV suite_declaration		{  }
  | declaration PV 				{  }
;


declaration:
  un_type VAR {  tableVar#empiler_variable $1 $2 }
;

un_type:
     BOOLEEN					{  ValeurBooleene  }
  |  ENTIER					{  ValeurEntiere  }
  |  REEL					{  ValeurReel  }
;

bloc_instruction:
  DEBUT suite_instruction FIN			
      {	
       tableVar#depiler_bloc ;
       new bloc $2 
      }
;

suite_instruction:
    instruction PV suite_instruction		{  $1::$3}
  | instruction PV 				{  $1::[] }
;

instruction:
    instruction_simple				{  $1 }
  | instruction_ctrl				{  $1 }
;

instruction_simple:
    affectation		   			{  $1 }
  | AFFICHER CHAINE				{  new afficherTxt $2 }
  | AFFICHER expression				{  new afficher $2 }
;

instruction_ctrl:					
  | boucle					{  $1 }
  | conditionnelle				{  $1 }
  | entree_bloc
    bloc_declaration bloc_instruction           {  $3 } 
	
;

affectation:
  VAR EGALE expression
      {
       let var = tableVar#trouve $1 in
       verifType var#typ $3#typ ;
       new affectation var $3
      }
;

boucle:
  TANTQUE expression FAIRE suite_instruction FIN_FAIRE
	{
		verifType ValeurBooleene $2#typ ;
		new tantque nosLabels#nouveau nosLabels#nouveau $2 $4
	}
;

conditionnelle:
    SI expression ALORS suite_instruction FIN_SI
	{
		verifType ValeurBooleene $2#typ ;
		new si nosLabels#nouveau $2 $4 
	}
  | SI expression ALORS suite_instruction 
    SINON suite_instruction FIN_SI
	{
		verifType ValeurBooleene $2#typ ;
		new siAlors nosLabels#nouveau nosLabels#nouveau $2 $4 $6
	}
;

const: 
    CONST_INT	{ new constante ValeurEntiere  $1 }
  | CONST_FLOAT	{ new constante ValeurReel $1     }
  | CONST_BOOL	{ new constante ValeurBooleene $1 }
;

operande:
    const { $1 }
  | VAR 	{ new evalV (tableVar#trouve $1) }
;


expression:
    MINUS expression %prec UMINUS	
	{
 		verifTypeCalc $2#typ;
		new op_unaire $2#typ (tableVar#nouveau $2#typ) "-" $2
	}
  | NON expression
	{
	 verifType ValeurBooleene $2#typ;
	 new op_unaire ValeurBooleene (tableVar#nouveau ValeurBooleene) "!" $2
	}
  | comp ET expression				
	{
	 verifType2 ValeurBooleene $1#typ $3#typ ;
	 new operation ValeurBooleene (tableVar#nouveau ValeurBooleene)
	   "&&" $1 $3
	}
  | comp OU expression				
	{
	 verifType2 ValeurBooleene $1#typ $3#typ ;
	 new operation ValeurBooleene (tableVar#nouveau ValeurBooleene)
	   "||" $1 $3
	}

  | comp
	{
		$1
	}
;

comp:
    terme EST_EGALE comp			
	{
	 verifType $1#typ $3#typ ;
	 new operation ValeurBooleene
	   (tableVar#nouveau ValeurBooleene) "==" $1 $3		
	}
  | terme EST_SUPERIEUR comp			
	{
	 verifType $1#typ $3#typ ;
	 new operation ValeurBooleene
	   (tableVar#nouveau ValeurBooleene) ">" $1 $3		
	}
  | terme EST_INFERIEUR  comp			
	{
  	 verifType $1#typ $3#typ ;
	 new operation ValeurBooleene
	   (tableVar#nouveau ValeurBooleene) "<" $1 $3
	}
  | terme
	{
		$1
	}
;
	    
terme:
    facteur PLUS terme				
	{
   	 verifTypeCalc2 $1#typ $3#typ ;
	 new operation $1#typ
	   (tableVar#nouveau $1#typ) "+" $1 $3		
	}
  | facteur MINUS terme
	{
     	 verifTypeCalc2 $1#typ $3#typ ;
	 new operation $1#typ
	   (tableVar#nouveau $1#typ) "-" $1 $3		
	}
  | facteur					
	{
		$1
	}
;

facteur:
    id TIMES facteur	
	{  
	   verifTypeCalc2 $1#typ $3#typ ;
	   new operation $1#typ
	     (tableVar#nouveau $1#typ) "*" $1 $3
	}
  | id DIV facteur
	{  
	   verifTypeCalc2 $1#typ $3#typ ;
	   new operation $1#typ (tableVar#nouveau $1#typ) "/" $1 $3
	}
  | id		
	{
		$1
	}
;

id:
    operande					{ $1 }
  | G_PAREN expression D_PAREN			{ $2 }  
;
