open TypeDef

exception Empty


(* Verification de type *)

let verifType type1 type2 =
  if type1 != type2
  then erreur "Type incorrect"
and verifType2 (request:typeBase) (t1:typeBase) (t2:typeBase) =
  if request != t1 or t1!=t2 then
    erreur "Type incorrect"

let verifTypeCalc (t1:typeBase) =
  if t1 == ValeurBooleene then
    erreur "Type incorrect";
and verifTypeCalc2 (t1:typeBase) (t2:typeBase) =
  if t1 == ValeurBooleene or t2 == ValeurBooleene then
    erreur "Type incorrect";
  verifType t1 t2;


(* Compteur de label *)

class compteurLabel =
  object
    val mutable i = 0
    method nouveau =
      i <- i + 1;
      "lbl_"^string_of_int(i)
  end

(* Une pile *)

class ['a] stack =
  object
    val mutable l = ([] : 'a list)
    method push x = l <- x::l
    method pop =
      match l with
	[]              -> raise Empty
      | element::l_fin 	-> l <- l_fin ; element
    method vider = l <- []
    method length = List.length l
  end

(* La table des symboles *)

class table_symboles =
  object(self)
    val mutable i = 0
    val mutable l = []
    val mutable hash_symboles =
      ((Hashtbl.create 5) : (string, variable) Hashtbl.t)
    val mutable variables_locales =
      new stack
    method empiler_bloc =
      variables_locales#push []
    method depiler_bloc =
      let list_tmp = variables_locales#pop in
      let n = List.length list_tmp in
      for i = 0 to n-1 do
	Hashtbl.remove hash_symboles (List.nth list_tmp i)#nom
      done
    method private nouveau_registre =
      i <- i + 1;
      "r_"^string_of_int(i)
    method nouveau typ =          (* pour allouer une nouveau registre *)
      let reg = self#nouveau_registre in
      l <- new variable typ reg "" :: l;
      reg
    method trouve nom =           (* pour retrouver une variable *)
      if not (Hashtbl.mem hash_symboles nom) then
	erreur ("Variable \""^nom^"\" non declare");
      Hashtbl.find hash_symboles nom
    method empiler_variable typ nom  =  (* pour ajouter une variable *)
      let elt_new = new variable typ (self#nouveau_registre) nom in
      l <- elt_new :: l;
      variables_locales#push (elt_new::variables_locales#pop) ;
      Hashtbl.add hash_symboles nom elt_new;
      elt_new
    method print =        (* affiche la definition de toute les variables *)
      Printf.printf "/* Variables : */\n";
      printall l
  end

let tableVar = new table_symboles

and nosLabels = new compteurLabel
